Index: /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java
===================================================================
--- /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java	(revision 134)
+++ /trunk/CrossPare/src/de/ugoe/cs/cpdp/training/GPTraining.java	(revision 135)
@@ -393,83 +762,152 @@
             }
         }
-        
+
         /**
          * Custom GT implementation used in the GP Algorithm.
-         */
-         public class GT extends MathCommand implements ICloneable {
-             
-             private static final long serialVersionUID = 113454184817L;
-
-             public GT(final GPConfiguration a_conf, java.lang.Class a_returnType) throws InvalidConfigurationException {
-                 super(a_conf, 2, a_returnType);
-             }
-
-             public String toString() {
-                 return "GT(&1, &2)";
-             }
-
-             public String getName() {
-                 return "GT";
-             }   
-
-             public float execute_float(ProgramChromosome c, int n, Object[] args) {
-                 float f1 = c.execute_float(n, 0, args);
-                 float f2 = c.execute_float(n, 1, args);
-
-                 float ret = 1.0f;
-                 if(f1 > f2) {
-                     ret = 0.0f;
-                 }
-
-                 return ret;
-             }
-
-             public double execute_double(ProgramChromosome c, int n, Object[] args) {
-                 double f1 = c.execute_double(n, 0, args);
-                 double f2 = c.execute_double(n, 1, args);
-
-                 double ret = 1;
-                 if(f1 > f2)  {
-                     ret = 0;
-                 }
-                 return ret;
-             }
-
-             public Object clone() {
-                 try {
-                     GT result = new GT(getGPConfiguration(), getReturnType());
-                     return result;
-                 }catch(Exception ex) {
-                     throw new CloneException(ex);
-                 }
-             }
-         }
+         * 
+         * @author Alexander Trautsch
+         */
+        public class GT extends MathCommand implements ICloneable {
+
+            /**
+             * generated serialization ID.
+             */
+            private static final long serialVersionUID = 113454184817L;
+
+            /**
+             * <p>
+             * Constructor. Creates a new GT.
+             * </p>
+             *
+             * @param a_conf
+             *            the configuration of the genetic program
+             * @param a_returnType
+             *            the return type
+             * @throws InvalidConfigurationException
+             *             thrown is there is a problem during the initialization of the super class
+             * 
+             * @see MathCommand
+             */
+            public GT(final GPConfiguration a_conf, @SuppressWarnings("rawtypes") java.lang.Class a_returnType)
+                throws InvalidConfigurationException
+            {
+                super(a_conf, 2, a_returnType);
+            }
+
+            /*
+             * (non-Javadoc)
+             * 
+             * @see org.jgap.gp.CommandGene#toString()
+             */
+            @Override
+            public String toString() {
+                return "GT(&1, &2)";
+            }
+
+            /*
+             * (non-Javadoc)
+             * 
+             * @see org.jgap.gp.CommandGene#getName()
+             */
+            @Override
+            public String getName() {
+                return "GT";
+            }
+
+            /*
+             * (non-Javadoc)
+             * 
+             * @see org.jgap.gp.CommandGene#execute_float(org.jgap.gp.impl.ProgramChromosome, int,
+             * java.lang.Object[])
+             */
+            @Override
+            public float execute_float(ProgramChromosome c, int n, Object[] args) {
+                float f1 = c.execute_float(n, 0, args);
+                float f2 = c.execute_float(n, 1, args);
+
+                float ret = 1.0f;
+                if (f1 > f2) {
+                    ret = 0.0f;
+                }
+
+                return ret;
+            }
+
+            /*
+             * (non-Javadoc)
+             * 
+             * @see org.jgap.gp.CommandGene#execute_double(org.jgap.gp.impl.ProgramChromosome, int,
+             * java.lang.Object[])
+             */
+            @Override
+            public double execute_double(ProgramChromosome c, int n, Object[] args) {
+                double f1 = c.execute_double(n, 0, args);
+                double f2 = c.execute_double(n, 1, args);
+
+                double ret = 1;
+                if (f1 > f2) {
+                    ret = 0;
+                }
+                return ret;
+            }
+
+            /*
+             * (non-Javadoc)
+             * 
+             * @see java.lang.Object#clone()
+             */
+            @Override
+            public Object clone() {
+                try {
+                    GT result = new GT(getGPConfiguration(), getReturnType());
+                    return result;
+                }
+                catch (Exception ex) {
+                    throw new CloneException(ex);
+                }
+            }
+        }
     }
-    
+
     /**
      * GP Multiple Data Sets Validation-Voting Classifier
      * 
-     * Basically the same as the GP Multiple Data Sets Validation Classifier.
-     * But here we do keep a model candidate for each training set which may later vote
+     * Basically the same as the GP Multiple Data Sets Validation Classifier. But here we do keep a
+     * model candidate for each training set which may later vote
      *
      */
     public class GPVVClassifier extends GPVClassifier {
 
+        /**
+         * generated serialization ID
+         */
         private static final long serialVersionUID = -654710583852839901L;
+
+        /**
+         * classifiers for each validation set
+         */
         private List<Classifier> classifiers = null;
-        
+
+        /*
+         * (non-Javadoc)
+         * 
+         * @see
+         * de.ugoe.cs.cpdp.training.GPTraining.GPVClassifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances arg0) throws Exception {
             // TODO Auto-generated method stub
-            
-        }
-        
-        /** Build the GP Multiple Data Sets Validation-Voting Classifier
-         * 
-         * This is according to Section 6 of the Paper by Liu et al.
-         * It is basically the Multiple Data Sets Validation Classifier but here we keep the best models an let them vote.
+        }
+
+        /**
+         * Build the GP Multiple Data Sets Validation-Voting Classifier
+         * 
+         * This is according to Section 6 of the Paper by Liu et al. It is basically the Multiple
+         * Data Sets Validation Classifier but here we keep the best models an let them vote.
          * 
          * @param traindataSet
+         *            the training data
          * @throws Exception
+         *             thrown in case of a problem with the training
          */
         public void buildClassifier(SetUniqueList<Instances> traindataSet) throws Exception {
@@ -478,36 +916,41 @@
             // then is evaluated on the rest
             classifiers = new LinkedList<>();
-            for(int i=0; i < traindataSet.size(); i++) {
+            for (int i = 0; i < traindataSet.size(); i++) {
 
                 // candidates we get out of evaluation
                 LinkedList<Classifier> candidates = new LinkedList<>();
-                
+
                 // number of runs, yields the best of these
-                double smallest_error_count_train = Double.MAX_VALUE; 
+                double smallest_error_count_train = Double.MAX_VALUE;
                 Classifier bestTrain = null;
-                for(int k=0; k < this.numberRuns; k++) {
-                    double[] errors_eval = {0.0, 0.0};
+                for (int k = 0; k < this.numberRuns; k++) {
+                    double[] errors_eval =
+                        { 0.0, 0.0 };
                     Classifier classifier = new GPRun();
-                    ((GPRun)classifier).configure(this.populationSize, this.initMinDepth, this.initMaxDepth, this.tournamentSize, this.maxGenerations, this.errorType2Weight, this.maxDepth, this.maxNodes);
-                    
+                    ((GPRun) classifier).configure(this.populationSize, this.initMinDepth,
+                                                   this.initMaxDepth, this.tournamentSize,
+                                                   this.maxGenerations, this.errorType2Weight,
+                                                   this.maxDepth, this.maxNodes);
+
                     // one project is training data
                     classifier.buildClassifier(traindataSet.get(i));
-                    
+
                     double[] errors;
                     // rest of the set is evaluation data, we evaluate now
-                    for(int j=0; j < traindataSet.size(); j++) {
-                        if(j != i) {
-                            // if type1 and type2 errors are < 0.5 we allow the model in the candidates
-                            errors = this.evaluate((GPRun)classifier, traindataSet.get(j));
+                    for (int j = 0; j < traindataSet.size(); j++) {
+                        if (j != i) {
+                            // if type1 and type2 errors are < 0.5 we allow the model in the
+                            // candidates
+                            errors = this.evaluate((GPRun) classifier, traindataSet.get(j));
                             errors_eval[0] += errors[0];
                             errors_eval[1] += errors[1];
-                            if((errors[0] < 0.5) && (errors[1] < 0.5)) {
+                            if ((errors[0] < 0.5) && (errors[1] < 0.5)) {
                                 candidates.add(classifier);
                             }
                         }
                     }
-                    
+
                     // if the candidate made fewer errors it is now the best
-                    if(errors_eval[0] + errors_eval[1] < smallest_error_count_train) {
+                    if (errors_eval[0] + errors_eval[1] < smallest_error_count_train) {
                         bestTrain = classifier;
                         smallest_error_count_train = errors_eval[0] + errors_eval[1];
@@ -515,29 +958,31 @@
                 }
 
-                // now after the evaluation we do a model selection where only one model remains for the given training data
+                // now after the evaluation we do a model selection where only one model remains for
+                // the given training data
                 // we select the model which is best on all evaluation data
                 double smallest_error_count = Double.MAX_VALUE;
                 double[] errors;
                 Classifier best = null;
-                for(int ii=0; ii < candidates.size(); ii++) {
-                    double[] errors_eval = {0.0, 0.0};
-                    
+                for (int ii = 0; ii < candidates.size(); ii++) {
+                    double[] errors_eval =
+                        { 0.0, 0.0 };
+
                     // we add the errors the candidate makes over the evaldata
-                    for(int j=0; j < traindataSet.size(); j++) {
-                        if(j != i) {
-                            errors = this.evaluate((GPRun)candidates.get(ii), traindataSet.get(j));
+                    for (int j = 0; j < traindataSet.size(); j++) {
+                        if (j != i) {
+                            errors = this.evaluate((GPRun) candidates.get(ii), traindataSet.get(j));
                             errors_eval[0] += errors[0];
                             errors_eval[1] += errors[1];
                         }
                     }
-                    
+
                     // if the candidate made fewer errors it is now the best
-                    if(errors_eval[0] + errors_eval[1] < smallest_error_count) {
+                    if (errors_eval[0] + errors_eval[1] < smallest_error_count) {
                         best = candidates.get(ii);
                         smallest_error_count = errors_eval[0] + errors_eval[1];
                     }
                 }
-                
-                if( best==null ) {
+
+                if (best == null) {
                     best = bestTrain;
                 }
@@ -546,47 +991,56 @@
             }
         }
-        
+
         /**
          * Use the best classifiers for each training data in a majority voting
+         * 
+         * @param instance
+         *            instance that is classified
+         * 
+         * @see de.ugoe.cs.cpdp.training.GPTraining.GPVClassifier#classifyInstance(weka.core.Instance)
          */
         @Override
         public double classifyInstance(Instance instance) {
-            
+
             int vote_positive = 0;
-            
+
             for (int i = 0; i < classifiers.size(); i++) {
                 Classifier classifier = classifiers.get(i);
-                
-                GPGenotype gp = ((GPRun)classifier).getGp();
-                Variable[] vars = ((GPRun)classifier).getVariables();
-                
-                IGPProgram fitest = gp.getAllTimeBest();  // all time fitest
-                for(int j = 0; j < instance.numAttributes()-1; j++) {
-                   vars[j].set(instance.value(j));
-                }
-                
-                if(fitest.execute_double(0, vars) < 0.5) {
+
+                GPGenotype gp = ((GPRun) classifier).getGp();
+                Variable[] vars = ((GPRun) classifier).getVariables();
+
+                IGPProgram fitest = gp.getAllTimeBest(); // all time fitest
+                for (int j = 0; j < instance.numAttributes() - 1; j++) {
+                    vars[j].set(instance.value(j));
+                }
+
+                if (fitest.execute_double(0, vars) < 0.5) {
                     vote_positive += 1;
                 }
             }
-            
-            if(vote_positive >= (classifiers.size()/2)) {
+
+            if (vote_positive >= (classifiers.size() / 2)) {
                 return 1.0;
-            }else {
+            }
+            else {
                 return 0.0;
             }
         }
     }
-    
+
     /**
      * GP Multiple Data Sets Validation Classifier
      * 
-     * We train a Classifier with one training project $numberRun times.
-     * Then we evaluate the classifier on the rest of the training projects and keep the best classifier.
-     * After that we have for each training project the best classifier as per the evaluation on the rest of the data set.
-     * Then we determine the best classifier from these candidates and keep it to be used later.
+     * We train a Classifier with one training project $numberRun times. Then we evaluate the
+     * classifier on the rest of the training projects and keep the best classifier. After that we
+     * have for each training project the best classifier as per the evaluation on the rest of the
+     * data set. Then we determine the best classifier from these candidates and keep it to be used
+     * later.
+     * 
+     * @author sherbold Alexander Trautsch
      */
     public class GPVClassifier extends AbstractClassifier {
-        
+
         private List<Classifier> classifiers = null;
         private Classifier best = null;
@@ -594,25 +1048,84 @@
         private static final long serialVersionUID = 3708714057579101522L;
 
+        /**
+         * size of the population of the genetic program
+         */
         protected int populationSize;
+
+        /**
+         * minimal depth of the S-expression tree at the start of the training
+         */
         protected int initMinDepth;
+
+        /**
+         * maximal depth of the S-expression tree at the start of the training
+         */
         protected int initMaxDepth;
+
+        /**
+         * size of the tournaments used for selection
+         */
         protected int tournamentSize;
+
+        /**
+         * number of genetic generations considered (i.e., number of iterations
+         */
         protected int maxGenerations;
+
+        /**
+         * weight factor for the prediction errors for cost estimation
+         */
         protected double errorType2Weight;
-        protected int numberRuns;
+
+        /**
+         * number of internal replications from which the best result is picked
+         */
+        protected int numberRuns = 20;
+
+        /**
+         * maximal depth of the S-expression tree
+         */
         protected int maxDepth;
+
+        /**
+         * maximal number of nodes of the S-expression tree
+         */
         protected int maxNodes;
 
         /**
+         * 
+         * <p>
          * Configure the GP Params and number of Runs
+         * </p>
          * 
          * @param populationSize
+         *            the population size
          * @param initMinDepth
+         *            the initial minimal depth of the S-expression tree
          * @param initMaxDepth
+         *            the initial maximal depth of the S-expression tree
          * @param tournamentSize
+         *            the tournament size for selection
          * @param maxGenerations
+         *            the number of generations created
          * @param errorType2Weight
-         */
-        public void configure(int populationSize, int initMinDepth, int initMaxDepth, int tournamentSize, int maxGenerations, double errorType2Weight, int numberRuns, int maxDepth, int maxNodes) {
+         *            weigth factor for the prediction errors
+         * @param numberRuns
+         *            number of internal replications from which the best result is picked
+         * @param maxDepth
+         *            maximal depth of the S-expression tree
+         * @param maxNodes
+         *            maximal number of nodes of the S-expression tree
+         */
+        public void configure(int populationSize,
+                              int initMinDepth,
+                              int initMaxDepth,
+                              int tournamentSize,
+                              int maxGenerations,
+                              double errorType2Weight,
+                              int numberRuns,
+                              int maxDepth,
+                              int maxNodes)
+        {
             this.populationSize = populationSize;
             this.initMinDepth = initMinDepth;
@@ -625,12 +1138,15 @@
             this.maxNodes = maxNodes;
         }
-        
-        /** Build the GP Multiple Data Sets Validation Classifier
-         * 
-         * This is according to Section 6 of the Paper by Liu et al. except for the selection of the best model.
-         * Section 4 describes a slightly different approach.
+
+        /**
+         * Build the GP Multiple Data Sets Validation Classifier
+         * 
+         * This is according to Section 6 of the Paper by Liu et al. except for the selection of the
+         * best model. Section 4 describes a slightly different approach.
          * 
          * @param traindataSet
+         *            the training data
          * @throws Exception
+         *             thrown in case of a problem with the training
          */
         public void buildClassifier(SetUniqueList<Instances> traindataSet) throws Exception {
@@ -638,24 +1154,28 @@
             // each classifier is trained with one project from the set
             // then is evaluated on the rest
-            for(int i=0; i < traindataSet.size(); i++) {
-                
+            for (int i = 0; i < traindataSet.size(); i++) {
+
                 // candidates we get out of evaluation
                 LinkedList<Classifier> candidates = new LinkedList<>();
-                
+
                 // numberRuns full GPRuns, we generate numberRuns models for each traindata
-                for(int k=0; k < this.numberRuns; k++) {
+                for (int k = 0; k < this.numberRuns; k++) {
                     Classifier classifier = new GPRun();
-                    ((GPRun)classifier).configure(this.populationSize, this.initMinDepth, this.initMaxDepth, this.tournamentSize, this.maxGenerations, this.errorType2Weight, this.maxDepth, this.maxNodes);
-                    
+                    ((GPRun) classifier).configure(this.populationSize, this.initMinDepth,
+                                                   this.initMaxDepth, this.tournamentSize,
+                                                   this.maxGenerations, this.errorType2Weight,
+                                                   this.maxDepth, this.maxNodes);
+
                     classifier.buildClassifier(traindataSet.get(i));
-                    
+
                     double[] errors;
 
                     // rest of the set is evaluation data, we evaluate now
-                    for(int j=0; j < traindataSet.size(); j++) {
-                        if(j != i) {
-                            // if type1 and type2 errors are < 0.5 we allow the model in the candidate list
-                            errors = this.evaluate((GPRun)classifier, traindataSet.get(j));
-                            if((errors[0] < 0.5) && (errors[1] < 0.5)) {
+                    for (int j = 0; j < traindataSet.size(); j++) {
+                        if (j != i) {
+                            // if type1 and type2 errors are < 0.5 we allow the model in the
+                            // candidate list
+                            errors = this.evaluate((GPRun) classifier, traindataSet.get(j));
+                            if ((errors[0] < 0.5) && (errors[1] < 0.5)) {
                                 candidates.add(classifier);
                             }
@@ -663,72 +1183,86 @@
                     }
                 }
-                
-                // now after the evaluation we do a model selection where only one model remains for the given training data
+
+                // now after the evaluation we do a model selection where only one model remains for
+                // the given training data
                 // we select the model which is best on all evaluation data
                 double smallest_error_count = Double.MAX_VALUE;
                 double[] errors;
                 Classifier best = null;
-                for(int ii=0; ii < candidates.size(); ii++) {
-                    double[] errors_eval = {0.0, 0.0};
-                    
+                for (int ii = 0; ii < candidates.size(); ii++) {
+                    double[] errors_eval =
+                        { 0.0, 0.0 };
+
                     // we add the errors the candidate makes over the evaldata
-                    for(int j=0; j < traindataSet.size(); j++) {
-                        if(j != i) {
-                            errors = this.evaluate((GPRun)candidates.get(ii), traindataSet.get(j));
+                    for (int j = 0; j < traindataSet.size(); j++) {
+                        if (j != i) {
+                            errors = this.evaluate((GPRun) candidates.get(ii), traindataSet.get(j));
                             errors_eval[0] += errors[0];
                             errors_eval[1] += errors[1];
                         }
                     }
-                    
+
                     // if the candidate made fewer errors it is now the best
-                    if(errors_eval[0] + errors_eval[1] < smallest_error_count) {
+                    if (errors_eval[0] + errors_eval[1] < smallest_error_count) {
                         best = candidates.get(ii);
                         smallest_error_count = errors_eval[0] + errors_eval[1];
                     }
                 }
-                
-                
+
                 // now we have the best classifier for this training data
                 classifiers.add(best);
 
             } /* endfor trainData */
-            
-            // now we have one best classifier for each trainData 
+
+            // now we have one best classifier for each trainData
             // we evaluate again to find the best classifier of all time
-            // this selection is now according to section 4 of the paper and not 6 where an average of the 6 models is build 
+            // this selection is now according to section 4 of the paper and not 6 where an average
+            // of the 6 models is build
             double smallest_error_count = Double.MAX_VALUE;
             double error_count;
             double errors[];
-            for(int j=0; j < classifiers.size(); j++) {
+            for (int j = 0; j < classifiers.size(); j++) {
                 error_count = 0;
                 Classifier current = classifiers.get(j);
-                for(int i=0; i < traindataSet.size(); i++) {
-                    errors = this.evaluate((GPRun)current, traindataSet.get(i));
+                for (int i = 0; i < traindataSet.size(); i++) {
+                    errors = this.evaluate((GPRun) current, traindataSet.get(i));
                     error_count = errors[0] + errors[1];
                 }
-                
-                if(error_count < smallest_error_count) {
+
+                if (error_count < smallest_error_count) {
                     best = current;
                 }
             }
         }
-        
+
+        /*
+         * (non-Javadoc)
+         * 
+         * @see weka.classifiers.Classifier#buildClassifier(weka.core.Instances)
+         */
         @Override
         public void buildClassifier(Instances traindata) throws Exception {
             final Classifier classifier = new GPRun();
-            ((GPRun)classifier).configure(populationSize, initMinDepth, initMaxDepth, tournamentSize, maxGenerations, errorType2Weight, this.maxDepth, this.maxNodes);
+            ((GPRun) classifier).configure(populationSize, initMinDepth, initMaxDepth,
+                                           tournamentSize, maxGenerations, errorType2Weight,
+                                           this.maxDepth, this.maxNodes);
             classifier.buildClassifier(traindata);
             classifiers.add(classifier);
         }
-        
-        /**
-         * Evaluation of the Classifier
-         * 
-         * We evaluate the classifier with the Instances of the evalData.
-         * It basically assigns the instance attribute values to the variables of the s-expression-tree and 
-         * then counts the missclassifications. 
+
+        /**
+         * <p>
+         * Evaluation of the Classifier.
+         * </p>
+         * <p>
+         * We evaluate the classifier with the Instances of the evalData. It basically assigns the
+         * instance attribute values to the variables of the s-expression-tree and then counts the
+         * missclassifications.
+         * </p>
          * 
          * @param classifier
+         *            the classifier that is evaluated
          * @param evalData
+         *            the validation data
          * @return
          */
@@ -736,7 +1270,8 @@
             GPGenotype gp = classifier.getGp();
             Variable[] vars = classifier.getVariables();
-            
-            IGPProgram fitest = gp.getAllTimeBest();  // selects the fitest of all not just the last generation
-            
+
+            IGPProgram fitest = gp.getAllTimeBest(); // selects the fitest of all not just the last
+                                                     // generation
+
             double classification;
             int error_type1 = 0;
@@ -744,58 +1279,67 @@
             int positive = 0;
             int negative = 0;
-            
-            for(Instance instance: evalData) {
-                
+
+            for (Instance instance : evalData) {
+
                 // assign instance attribute values to the variables of the s-expression-tree
                 double[] tmp = WekaUtils.instanceValues(instance);
-                for(int i = 0; i < tmp.length; i++) {
+                for (int i = 0; i < tmp.length; i++) {
                     vars[i].set(tmp[i]);
                 }
-                
+
                 classification = fitest.execute_double(0, vars);
-                
+
                 // we need to count the absolutes of positives for percentage
-                if(instance.classValue() == 1.0) {
-                    positive +=1;
-                }else {
-                    negative +=1;
-                }
-                
+                if (instance.classValue() == 1.0) {
+                    positive += 1;
+                }
+                else {
+                    negative += 1;
+                }
+
                 // classification < 0.5 we say defective
-                if(classification < 0.5) {
-                    if(instance.classValue() != 1.0) {
+                if (classification < 0.5) {
+                    if (instance.classValue() != 1.0) {
                         error_type1 += 1;
                     }
-                }else {
-                    if(instance.classValue() == 1.0) {
+                }
+                else {
+                    if (instance.classValue() == 1.0) {
                         error_type2 += 1;
                     }
                 }
             }
-            
-            // return error types percentages for the types 
+
+            // return error types percentages for the types
             double et1_per = error_type1 / negative;
-            double et2_per = error_type2 / positive; 
-            return new double[]{et1_per, et2_per};
-        }
-        
+            double et2_per = error_type2 / positive;
+            return new double[]
+                { et1_per, et2_per };
+        }
+
         /**
          * Use only the best classifier from our evaluation phase
+         * 
+         * @param instance
+         *            instance that is classified
+         * 
+         * @see weka.classifiers.AbstractClassifier#classifyInstance(weka.core.Instance)
          */
         @Override
         public double classifyInstance(Instance instance) {
-            GPGenotype gp = ((GPRun)best).getGp();
-            Variable[] vars = ((GPRun)best).getVariables();
-            
-            IGPProgram fitest = gp.getAllTimeBest();  // all time fitest
-            for(int i = 0; i < instance.numAttributes()-1; i++) {
-               vars[i].set(instance.value(i));
-            }
-            
+            GPGenotype gp = ((GPRun) best).getGp();
+            Variable[] vars = ((GPRun) best).getVariables();
+
+            IGPProgram fitest = gp.getAllTimeBest(); // all time fitest
+            for (int i = 0; i < instance.numAttributes() - 1; i++) {
+                vars[i].set(instance.value(i));
+            }
+
             double classification = fitest.execute_double(0, vars);
-            
-            if(classification < 0.5) {
+
+            if (classification < 0.5) {
                 return 1.0;
-            }else {
+            }
+            else {
                 return 0.0;
             }
